import { EngagementMedium } from '../types';
/**
 *
 * The AnalyticsApi class is a wrapper around the Analytics Endpoints of
 * the SaaSquatch REST API. Used to record Widget events.
 *
 * @hidden
 */
export default class AnalyticsApi {
    domain: string;
    /**
     * Initialize a new {@link AnalyticsApi} instance.
     *
     * @param {Object} config Config details
     * @param {string} [config.domain='https://app.referralsaasquatch.com'] The server domain.
     *
     */
    constructor(config: {
        domain: string;
    });
    pushAnalyticsLoadEvent(params: SQHDetails): Promise<any> | undefined;
    pushAnalyticsShareClickedEvent(params: SQHDetails & {
        shareMedium: string;
    }): Promise<any>;
}
export type SQHDetails = {
    tenantAlias: string;
    externalAccountId: string;
    externalUserId: string;
    engagementMedium: EngagementMedium;
    programId?: string;
};
