import { default as Widget, Params } from './Widget';
/**
 * An EmbedWidget is displayed inline in part of your page.
 *
 * To create an EmbedWidget use {@link Widgets}
 *
 * @example
 * const widget = new EmbedWidget({ ... })
 * widget.load() // Loads widget into the DOM
 * widget.open() // Makes the iframe container visible
 * widget.close() // Hides the iframe container
 */
export default class EmbedWidget extends Widget {
    constructor(params: Params, container?: HTMLElement | string);
    load(): Promise<void>;
    /**
     * Un-hide if element is available and refresh data
     */
    open(): void;
    close(): void;
    protected _error(rs: any, mode?: string, style?: string): string;
    private _shouldFireLoadEvent;
    show: () => void;
    hide: () => void;
}
