import { default as Widget, Params } from './Widget';
/**
 * The PopupWidget is used to display popups (also known as "Modals").
 * Popups widgets are rendered on top of other elements in a page.
 *
 * To create a PopupWidget use {@link Widgets}
 *
 * @example
 * const widget = new PopupWidget({ ... })
 * widget.load() // Loads the widget into a dialog element
 * widget.open() // Opens the dialog element
 * widget.close() // Hides the dialog element
 */
export default class PopupWidget extends Widget {
    trigger: string | null;
    id: string;
    constructor(params: Params, trigger?: string | null);
    _initialiseCTA(): void;
    _createPopupDialog(): HTMLDialogElement;
    load(): Promise<void>;
    protected _setupResizeHandler(frame: HTMLIFrameElement): Promise<void>;
    open(): void;
    close(): void;
    protected _clickedOutside({ target }: {
        target: any;
    }): void;
    protected _error(rs: any, mode?: string, style?: string): string;
    show: () => void;
    hide: () => void;
}
