import { default as DeclarativeWidget } from './DeclarativeWidget';
/**
 * Base class for `squatch-embed` web-component
 * @extends {DeclarativeWidget}
 * @class
 * @example
 * window.createCustomElement('squatch-embed', DeclarativeEmbedWidget)
 * const widget = document.querySelector('squatch-embed') as DeclarativeEmbedWidget
 * widget.open()
 * widget.close()
 * widget.reload()
 */
export declare class DeclarativeEmbedWidget extends DeclarativeWidget {
    constructor();
    static get observedAttributes(): string[];
    attributeChangedCallback(attr: string, oldVal: string, newVal: string): void;
    connectedCallback(): Promise<void>;
}
/**
 * Base class for `squatch-popup` web-component
 * @extends {DeclarativeWidget}
 * @class
 * @example
 * window.createCustomElement('squatch-popup', DeclarativePopupWidget)
 * const widget = document.querySelector('squatch-popup') as DeclarativePopupWidget
 * widget.open()
 * widget.close()
 * widget.reload()
 */
export declare class DeclarativePopupWidget extends DeclarativeWidget {
    constructor();
    static get observedAttributes(): string[];
    attributeChangedCallback(attr: string, oldVal: string, newVal: string): void;
    connectedCallback(): Promise<void>;
}
